package formula;

class Cell {
  Exp formula;
  boolean upToDate = false;
  boolean undef = false;
  double value = 0;
  
  public Cell(Exp expression) {
    formula = expression;
  }

  public void setCell(Exp expression) {
    formula = expression;
    upToDate = false;
    undef = false;
  }

  double eval(int rowNum) throws UndefinedCellException {
    if (undef)
      throw new UndefinedCellException(null, rowNum);
    else if (!upToDate) {
      upToDate = true;
      undef = true;
      value = formula.eval(rowNum);
      undef = false;
    }
    return value;
  }
}
