package formula;

import formula.*;
import java.util.*;

class ConditionalExp extends Exp {
  Exp conditionExp;
  Exp trueExp;
  Exp falseExp;
  double eval(int rowNum) throws UndefinedCellException {
    if (conditionExp.eval(rowNum) != 0) {
      return trueExp.eval(rowNum);
    }
    else 
      return falseExp.eval(rowNum);
  }

  ConditionalExp(Exp ifExp, Exp thenExp, Exp elseExp) {
    conditionExp = ifExp;
    trueExp = thenExp;
    falseExp = elseExp;
  }
}
